<template>
  <el-main>
    <el-row>
      <el-col :span="12">
        <label>input</label>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="24">
        <el-input type="textarea" placeholder="== file1.txt ==
111
222
== file2.txt ==
333
444
" :rows="10" v-model="input"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <span>separator(regexp): </span>
        <el-input placeholder="== (?<name>.+?) ==" :rows="10" v-model="separator"></el-input>
      </el-col>
      <el-col :span="12">
        <span>filename(auto increment: ${_num_}): </span>
        <el-input placeholder="${_num_}_${name}" :rows="10" v-model="filename"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2" :offset="11">
        <el-button @click="split" type="primary" round>変換！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2" :offset="11">
        <el-button @click="download" type="primary" round>zipでダウンロード！</el-button>
      </el-col>
    </el-row>
    <template v-for="file in (files || [])">
      <el-row>
        <el-col :span="24">
          <label>{{ file.filename }}</label>
        </el-col>
        <el-col :span="24">
          <el-input type="textarea" :rows="10" v-model="file.content"></el-input>
        </el-col>
      </el-row>
    </template>
  </el-main>
</template>

<script>
import _ from 'lodash'
import jszip from 'jszip'
import FileSaver from 'file-saver'

export default{
  data() {
    return {
      separator: "",
      filename: "",
      input: "",
      files: [],
    }
  },
  methods:{
    split() {
      this.files = []
      let filename = ""
      let content = ""
      let file_count = 1
      const sep_reg = RegExp(this.separator, "u")
      const lines = this.input.split("\n")

      _.forEach(lines, (line) => {
        let match
        if (match = sep_reg.exec(line)) {
          if (content !== "") {
            this.files.push({
              filename: filename,
              content: content
            })

            content = ""
          }

          filename = this.createFilename(this.filename, match, file_count++)
        } else {
          content += line + "\n"
        }
      })

      if (content && filename) {
        this.files.push({
          filename: filename,
          content: content
        })
      }
    },

    download() {
      if (this.files.length == 0) {
        this.$message({
          showClose: true,
          message: "まずは変換！ボタンを押してください",
          type: "error"
        })
        return
      }

      const zip = new jszip()

      _.forEach(this.files, (file) => {
        let pathes = file.filename.split(/[\\\/]/)
        let fname = pathes.pop()

        let z = zip.folder(_.filter(pathes, (p) => p !== "").join("/"))

        z.file(fname, file.content)
      })

      zip.generateAsync({type: "blob"}).then((blob) => {
        FileSaver.saveAs(blob, "download.zip")
      })
    },

    createFilename(pattern, match, num) {
      if (!pattern || pattern === "") {
        return `file_${num}.txt`
      }

      let filename = pattern
      let filename_matches
      if (filename_matches = pattern.match(/(?:\$\{)([^}]+?)(?:\})/gm)) {
        _.forEach(filename_matches, (m) => {
          const key = m.slice(2, -1)

          if (key === "_num_") {
            filename = filename.replace("${_num_}", num)
          } else {
            filename = filename.replace(m, (match.groups[key] || m))
          }
        })
      }

      return filename
    }
  }
}
</script>
